#!/bin/sh
led_red_on ()
{
	echo 1 > /sys/class/gpio/gpio2/value
	echo 0 > /sys/class/gpio/gpio3/value
	echo 0 > /sys/class/gpio/gpio4/value
}
led_green_on ()
{
	echo 0 > /sys/class/gpio/gpio2/value
	echo 1 > /sys/class/gpio/gpio3/value
	echo 0 > /sys/class/gpio/gpio4/value
}
led_blue_on ()
{
	echo 0 > /sys/class/gpio/gpio2/value
	echo 0 > /sys/class/gpio/gpio3/value
	echo 1 > /sys/class/gpio/gpio4/value
}
led_yellow_on ()
{
	echo 1 > /sys/class/gpio/gpio2/value
	echo 1 > /sys/class/gpio/gpio3/value
	echo 0 > /sys/class/gpio/gpio4/value
}
led_while_on ()
{
	echo 1 > /sys/class/gpio/gpio2/value
	echo 1 > /sys/class/gpio/gpio3/value
	echo 1 > /sys/class/gpio/gpio4/value
}
led_off ()
{
	echo 0 > /sys/class/gpio/gpio2/value
	echo 0 > /sys/class/gpio/gpio3/value
	echo 0 > /sys/class/gpio/gpio4/value
}
check_usb_install_ipk ()
{
	if [ `df | grep /tmp/testdisk | awk -F " " '{print $6}'` ];then

	currentinnerversion=`opkg info fw_yfminer | grep Version  | awk -F ": " '{print $2}' | awk -F "." '{print $4}'`
	maxinnerversion="0"
	installfile="0"

		for file in `ls /tmp/testdisk  | grep fw_yfminer_ | grep _meson.ipk`
		do
			innerversion=`echo $file | awk -F "_" '{print $3}' | awk -F "." '{print $4}'`
			echo $innerversion
			if [ "$maxinnerversion" -le "$innerversion" ];then
				maxinnerversion=$innerversion
				installfile=$file
			fi
		done

		echo $maxinnerversion
		echo $installfile

		if [ "$installfile" != "0" ] && [ "$maxinnerversion" -ne "$currentinnerversion" ];then
			opkg install /tmp/testdisk/$installfile
			for i in 1 2 3
			do
				led_red_on
				sleep 1
				led_green_on
				sleep 1
				led_blue_on
				sleep 1
			done
			reboot -f
		fi
	fi
}
check_usb_reset_passwd_to_none ()
{
	passwdFile="/tmp/testdisk/yfminer@@reset##passwd##to@@none##" 
	isnoneshadow=`cat /etc/shadow  | grep root | awk -F ":" '{print $2}'`
	if [ $isnoneshadow ];then
		if [ `df | grep /tmp/testdisk | awk -F " " '{print $6}'` ];then	
			if [ -f "$passwdFile" ];then
			
				cp /yfminer/etc/shadow_none /etc/shadow
				sync
				for i in 1 2 3 4 5
				do
					led_yellow_on
					sleep 1
					led_off
					sleep 1
				done
				reboot -f
			fi
		fi
	fi
	
}
check_usb_reset_to_factorymode ()
{
	flagFIle="/tmp/testdisk/yfminer@@reset##to@@factorymode##" 
	flagvalue=`fw_printenv yf_softmode 2>/dev/null | grep yf_softmode | awk -F "=" '{print $2}'`
	if [ "$flagvalue" == "factory" ];then		
		echo "already on factory"
	else
		if [ `df | grep /tmp/testdisk | awk -F " " '{print $6}'` ];then
		
			if [ -f "$flagFIle" ];then
			
				factory restore factory
				
				for i in 1 2 3 4 5
				do
					led_while_on
					sleep 1
					led_off
					sleep 1
				done
				reboot -f
			fi
		fi
	fi
}
check_usb_to_laohuamode ()
{
	flagFIle="/tmp/testdisk/yfminer##@@to##@@laohuamode##@@" 
	if [ `df | grep /tmp/testdisk | awk -F " " '{print $6}'` ];then
		
		if [ -f "$flagFIle" ];then
			echo "enter laohua mode success"
			fw_setenv yf_softmode laohuamode 2>/dev/null 1>&2	
			cp /yfminer/etc/shadow_none /etc/shadow			
		fi
	fi
}
check_usb_to_defaultmode ()
{
	flagFIle="/tmp/testdisk/yfminer##@@to##@@defaultmode##@@" 
	if [ `df | grep /tmp/testdisk | awk -F " " '{print $6}'` ];then
		
		if [ -f "$flagFIle" ];then
			echo "enter laohua mode success"
			fw_setenv yf_softmode default 2>/dev/null 1>&2
			cp /yfminer/etc/shadow_default /etc/shadow
			sync		
		fi
	fi
}

check_usb_action ()
{
if [ -b "/dev/sda1" ];then
mkdir /tmp/testdisk/
mount /dev/sda1 /tmp/testdisk
check_usb_install_ipk
#check_usb_reset_passwd_to_none
check_usb_reset_to_factorymode
check_usb_to_laohuamode
check_usb_to_defaultmode
umount /tmp/testdisk
rm -rf /tmp/testdisk
fi
}
init_mac_addr ()
{
	macaddr=`fw_printenv macaddr 2>/dev/null | grep macaddr | awk -F "=" '{print $2}'`
	if [ ! $macaddr ];then		
		echo "mac addr not set"
		fw_setenv yf_softmode factory 2>/dev/null 1>&2
        cp /yfminer/etc/shadow_none /etc/shadow
        sync
	else
		ifconfig eth0 down
		ifconfig eth0 hw ether $macaddr
		ifconfig eth0 up
		echo "set macaddr $retvalue success"
	fi
}
init_env ()
{
echo 2 > /sys/class/gpio/export
echo 3 > /sys/class/gpio/export
echo 4 > /sys/class/gpio/export
echo 5 > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio2/direction
echo out > /sys/class/gpio/gpio3/direction
echo out > /sys/class/gpio/gpio4/direction
echo in > /sys/class/gpio/gpio5/direction
}
run_app ()
{
/yfminer/miner &
}

init_mac_addr
init_env
check_usb_action
SOFTMODE=`fw_printenv yf_softmode 2>/dev/null | grep yf_softmode | awk -F "=" '{print $2}'`
if [ "$SOFTMODE" == "factory" ]; then
ifconfig eth0 192.168.11.100
led_green_on
factory
elif [ "$SOFTMODE" == "laohuamode" ]; then
ifconfig eth0 192.168.11.100
led_while_on
sh /yfminer/laohuatest.sh 2>/dev/null 1>&2 &
else
led_blue_on
run_app
fi
exit 0
